## compiz 0.9.14.1+20.04.20200211-0ubuntu1

=== compizconfig/ccsm/CMakeLists.txt ===
find_package (CompizConfig REQUIRED)
include (LibCompizConfigCommon)

# Hack
set (CMAKE_PROJECT_NAME ccsm)

add_custom_command (OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/compizconfig_wrapper.c
		    COMMAND echo \"int main (void) { return 0\; }\" >> ${CMAKE_CURRENT_BINARY_DIR}/compizconfig_wrapper.c
		    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

# Get arch
execute_process (COMMAND uname -p OUTPUT_VARIABLE PROC_ARCH)
string (REPLACE "\n" "" PROC_ARCH ${PROC_ARCH})

# Get Python Version
find_package (PythonInterp 3.0 REQUIRED)

set (PY_VERSION "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
set (PY_BUILD_DIR lib.linux-${PROC_ARCH}-${PY_VERSION})
set (PY_SCRIPTS_DIR scripts-${PY_VERSION})

set (PY_CCSM_LIB  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_BUILD_DIR}/ccm/Conflicts.py
		  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_BUILD_DIR}/ccm/Constants.py
		  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_BUILD_DIR}/ccm/__init__.py
		  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_BUILD_DIR}/ccm/Pages.py
		  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_BUILD_DIR}/ccm/Settings.py
		  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_BUILD_DIR}/ccm/Utils.py
		  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_BUILD_DIR}/ccm/Widgets.py
		  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_BUILD_DIR}/ccm/Window.py
		  ${CMAKE_CURRENT_BINARY_DIR}/build/${PY_SCRIPTS_DIR}/ccsm)

file (READ ${CMAKE_SOURCE_DIR}/VERSION COMPIZ_RELEASE_VERSION LIMIT 12 OFFSET 0)
string (STRIP ${COMPIZ_RELEASE_VERSION} COMPIZ_RELEASE_VERSION)
set (VERSION ${COMPIZ_RELEASE_VERSION})

add_custom_command (OUTPUT ${PY_CCSM_LIB}
		    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/setup.py build --build-base=${CMAKE_CURRENT_BINARY_DIR}/build --version=${VERSION}
		    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		    COMMENT "Generating Python Bytecode")

add_custom_target (ccsm_module ALL DEPENDS
                   ${PY_CCSM_LIB})

set (UNINSTALL_COMMAND "${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/setup.py uninstall --prefix=${CMAKE_INSTALL_PREFIX} --version=${VERSION}")

compiz_add_code_to_uninstall_target (${UNINSTALL_COMMAND} ${CMAKE_CURRENT_SOURCE_DIR})

install (CODE
	 "message (\"Installing python files\")
	  execute_process (COMMAND cmake -DPY_EXECUTABLE=${PYTHON_EXECUTABLE} -DSETUP=${CMAKE_CURRENT_SOURCE_DIR}/setup.py -DPREFIX=${CMAKE_INSTALL_PREFIX} -DWDIR=${CMAKE_CURRENT_SOURCE_DIR} -DVERSION=${VERSION} -P ${compiz_SOURCE_DIR}/compizconfig/cmake/exec_setup_py_with_destdir.cmake)")

=== plugins/animationjc/CMakeLists.txt ===
find_package (Compiz REQUIRED)
include (CompizPlugin)

compiz_plugin (animationjc PLUGINDEPS composite opengl animation)

=== plugins/scaleaddon/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

compiz_plugin (scaleaddon PLUGINDEPS composite opengl text scale)

=== plugins/screenshot/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

compiz_plugin(screenshot PLUGINDEPS composite opengl compiztoolbox)

=== plugins/showdesktop/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

compiz_plugin (showdesktop PLUGINDEPS composite opengl)

=== plugins/staticswitcher/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

compiz_plugin (staticswitcher PLUGINDEPS composite opengl compiztoolbox)

=== src/point/CMakeLists.txt ===
pkg_check_modules (
  GLIBMM
  REQUIRED
  glibmm-2.4 glib-2.0
)

INCLUDE_DIRECTORIES (  
  ${compiz_SOURCE_DIR}/include
  ${Boost_INCLUDE_DIRS}
  ${GLIBMM_INCLUDE_DIRS}
)

LINK_DIRECTORIES (${GLIBMM_LIBRARY_DIRS}) 

SET ( 
  PUBLIC_HEADERS 
  ${compiz_SOURCE_DIR}/include/core/point.h
)

SET ( 
  PRIVATE_HEADERS 
)

SET( 
  SRCS 
  ${CMAKE_CURRENT_SOURCE_DIR}/src/point.cpp
)

ADD_LIBRARY( 
  compiz_point STATIC
  
  ${SRCS}
  
  ${PUBLIC_HEADERS}
  ${PRIVATE_HEADERS}
)

IF (COMPIZ_BUILD_TESTING)
ADD_SUBDIRECTORY( ${CMAKE_CURRENT_SOURCE_DIR}/tests )
ENDIF (COMPIZ_BUILD_TESTING)

SET_TARGET_PROPERTIES(
  compiz_point PROPERTIES
  PUBLIC_HEADER "${PUBLIC_HEADERS}"
)

install (FILES ${PUBLIC_HEADERS} DESTINATION ${COMPIZ_CORE_INCLUDE_DIR})

TARGET_LINK_LIBRARIES( 
  compiz_point
  
  ${GLIBMM_LIBRARIES}
)

=== compizconfig/gsettings/gsettings_backend_shared/CMakeLists.txt ===
compiz_pkg_check_modules (GSETTINGS_UTIL ${_deps})

if (GSETTINGS_UTIL_FOUND)

    set (GSETTINGS_UTIL_LIB_INCLUDES
         ${CMAKE_CURRENT_SOURCE_DIR}
         ${CMAKE_SOURCE_DIR}/compizconfig/integration/gnome/include
         ${CMAKE_SOURCE_DIR}/compizconfig/integration/gnome/gsettings/include
	 ${compiz_SOURCE_DIR}/compizconfig/libcompizconfig/include
	 ${GSETTINGS_UTIL_INCLUDE_DIRS}
	 ${CMAKE_CURRENT_SOURCE_DIR}/../src)

    include_directories (${GSETTINGS_UTIL_LIB_INCLUDES})

    link_directories (${GSETTINGS_UTIL_LIBRARY_DIRS}
		      ${compiz_BINARY_DIR}/compizconfig/libcompizconfig
                      ${compiz_BINARY_DIR}/compizconfig/integration/gnome
                      ${CMAKE_BINARY_DIR}/compizconfig/integration/gnome/gsettings)

    add_library (compizconfig_gsettings_backend_interface STATIC
                 ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_backend_interface.c)

    add_library (compizconfig_gsettings_wrapper_factory_interface STATIC
                 ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_wrapper_factory_interface.c)

    add_library (compizconfig_gsettings_wrapper_factory STATIC
                 ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_wrapper_factory.c)

    add_library (compizconfig_gsettings_wrapper_interface STATIC
                 ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_interface.c)

    add_library (compizconfig_gsettings_wrapper STATIC
                 ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_interface_wrapper.c)

    target_link_libraries (compizconfig_gsettings_wrapper
                           compizconfig
                           ${GSETTINGS_UTIL_LIBRARIES})

    add_library (compizconfig_gsettings_util STATIC
                 ${CMAKE_CURRENT_SOURCE_DIR}/gsettings_constants.c
                 ${CMAKE_CURRENT_SOURCE_DIR}/gsettings_util.c)

    target_link_libraries (compizconfig_gsettings_util
                           compizconfig_gsettings_backend_interface
                           compizconfig_gsettings_wrapper_interface
                           compizconfig
                           ${GSETTINGS_UTIL_LIBRARIES})

    add_library (compizconfig_gsettings_backend SHARED
                 ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_backend.c)

    set (GSETTINGS_BACKEND_SHARED_ADDITIONAL_LIBRARIES
	 compizconfig_gsettings_backend_interface
	 compizconfig_gsettings_util
	 compizconfig_gsettings_wrapper
	 compizconfig_gnome_integration
	 compizconfig_gnome_integration_gsettings_integrated_setting
	 compizconfig_gnome_integration_gsettings_setting_factory
	 compizconfig_gnome_integration_gsettings_wrapper_factory
	 compizconfig_gsettings_wrapper_factory_interface
	 compizconfig_gsettings_wrapper_factory
	 compizconfig)

    target_link_libraries (compizconfig_gsettings_backend
			   ${GSETTINGS_BACKEND_SHARED_ADDITIONAL_LIBRARIES}
                           ${GSETTINGS_UTIL_LIBRARIES})

    install (TARGETS compizconfig_gsettings_backend
             DESTINATION ${libdir})

endif (GSETTINGS_UTIL_FOUND)

=== src/string/tests/CMakeLists.txt ===
include_directories( 
  ${CMAKE_CURRENT_SOURCE_DIR} 
)

add_executable( 
  compiz_string_test
  
  ${CMAKE_CURRENT_SOURCE_DIR}/printf/src/test-string-printf.cpp
)

target_link_libraries( 
  compiz_string_test 
  
  compiz_string
  
  ${GTEST_BOTH_LIBRARIES}
)

compiz_discover_tests (compiz_string_test COVERAGE compiz_string)

=== src/timer/tests/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_library (compiz_timer_test
             ${CMAKE_CURRENT_SOURCE_DIR}/test-timer.cpp)

add_executable (compiz_timer_callbacks
                ${CMAKE_CURRENT_SOURCE_DIR}/callbacks/src/test-timer-callbacks.cpp)

add_executable (compiz_timer_diffs
                ${CMAKE_CURRENT_SOURCE_DIR}/diffs/src/test-timer-diffs.cpp)

add_executable (compiz_timer_set-values
                ${CMAKE_CURRENT_SOURCE_DIR}/set-values/src/test-timer-set-values.cpp)

add_executable (compiz_timer_while-calling
                ${CMAKE_CURRENT_SOURCE_DIR}/while-calling/src/test-timer-set-times-while-calling.cpp)

target_link_libraries (compiz_timer_callbacks 
                       compiz_timer_test
                       compiz_timer 
                       ${GTEST_BOTH_LIBRARIES}
		       ${GMOCK_LIBRARY}
		       ${GMOCK_MAIN_LIBRARY})

target_link_libraries (compiz_timer_diffs
                       compiz_timer_test
                       compiz_timer 
                       ${GTEST_BOTH_LIBRARIES}
		       ${GMOCK_LIBRARY}
		       ${GMOCK_MAIN_LIBRARY})

target_link_libraries (compiz_timer_set-values
                       compiz_timer_test
                       compiz_timer 
                       ${GTEST_BOTH_LIBRARIES}
		       ${GMOCK_LIBRARY}
		       ${GMOCK_MAIN_LIBRARY})

target_link_libraries (compiz_timer_while-calling
                       compiz_timer_test
                       compiz_timer 
                       ${GTEST_BOTH_LIBRARIES}
		       ${GMOCK_LIBRARY}
		       ${GMOCK_MAIN_LIBRARY})

compiz_discover_tests (compiz_timer_callbacks COVERAGE compiz_timer)
compiz_discover_tests (compiz_timer_diffs COVERAGE compiz_timer)
compiz_discover_tests (compiz_timer_set-values COVERAGE compiz_timer)
compiz_discover_tests (compiz_timer_while-calling COVERAGE compiz_timer)

=== tests/xorg-gtest/plugins/testhelper/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

include_directories (${COMPIZ_XORG_GTEST_COMMUNICATOR_INCLUDE_DIR})

set (COMPIZ_PLUGIN_PACK_BUILD 1)
compiz_plugin (testhelper NOINSTALL LIBRARIES ${COMPIZ_XORG_GTEST_COMMUNICATOR_LIBRARY})

=== debian/control ===
Source: compiz
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Uploaders: David Nusinow <dnusinow@debian.org>, Sean Finney <seanius@debian.org>, Cyril Brulebois <kibi@debian.org>
Build-Depends: cmake (>= 3.10.0),
               debhelper (>= 9~),
               dh-python,
               dh-translations,
               libgtest-dev (>= 1.8.0),
               libgmock-dev (>= 1.8.0),
               intltool,
               libtool,
               pkg-config (>= 0.29.1),
               quilt (>= 0.40),
               libcairo2-dev,
               libdbus-glib-1-dev,
               libgl1-mesa-dev (>= 6.5.1) [!armhf !armel] | libgl-dev [!armhf !armel],
               libegl1-mesa-dev [armhf armel], libgles2-mesa-dev [armhf armel],
               libboost-dev,
               libboost-serialization-dev,
               libglib2.0-dev,
               libglibmm-2.4-dev,
               libgtk-3-dev,
               libice-dev (>= 1:1.0.1), 
               libmetacity-dev (>= 1:3.22.0),
               libpango1.0-dev,
               libpng-dev,
               librsvg2-dev, 
               libsm-dev (>= 1:1.0.1),
               libwnck-3-dev,
               libx11-dev,
               libxcomposite-dev (>= 1:0.3-2),
               libxext-dev,
               libxdamage-dev (>=1:1.0.3),
               libxfixes-dev (>= 1:4.0.1),
               libxi-dev,
               libxinerama-dev, 
               libxml-parser-perl,
               libxorg-gtest-dev,
               libxrandr-dev (>= 2:1.1.0.2),
               libxrender-dev (>= 1:0.9.1), 
               libxcursor-dev,
               libxml2-dev,
               libxslt1-dev,
               xsltproc,
               libstartup-notification0-dev (>= 0.7),
               x11proto-gl-dev (>= 1.4.8),
               libglu1-mesa-dev [!armhf !armel],
               libjpeg-dev,
               libnotify-dev (>= 0.7.0),
               libx11-xcb-dev,
               libprotobuf-dev,
               protobuf-compiler,
               python3-all-dev,
               cython3,
               gsettings-desktop-schemas-dev,
               xserver-xorg-dev (>= 0.7.0),
Standards-Version: 3.9.8
Vcs-Git: https://git.launchpad.net/~compiz-team/compiz
Vcs-Browser: https://git.launchpad.net/~compiz-team/compiz?h=master
Homepage: https://launchpad.net/compiz

Package: compiz
Architecture: all
Provides: x-window-manager
Depends: compiz-core (>= ${source:Version}),
         compiz-plugins-default (>= ${source:Version}),
         compiz-gnome,
         ${misc:Depends},
Description: OpenGL window and compositing manager
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This metapackage provides the components necessary for running compiz. It
 provides the compiz core, a set of standard plugins, a window decorator using
 the Gtk toolkit and the files necessary to integrate compiz with the GNOME
 desktop environment.

Package: compiz-core
Architecture: any
Multi-Arch: no
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
Recommends: compiz-plugins-default,
Provides: compiz-core-abiversion-${coreabiversion}
Replaces: compizconfig-settings-manager (<< 0.9.8)
Description: OpenGL window and compositing manager
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 Compiz combines together a window manager and a composite manager using
 OpenGL for rendering. A "window manager" allows the manipulation of the
 multiple applications and dialog windows that are presented on the screen. A
 "composite manager" allows windows and other graphics to be combined together
 to create composite images. Compiz achieves its stunning effects by doing
 both of these functions.

Package: compiz-dev
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: compiz-core (= ${binary:Version}),
         libdecoration0-dev (= ${binary:Version}),
         ${misc:Depends},
         compiz-plugins-default (= ${binary:Version}),
         libgl1-mesa-dev [!armhf !armel] | libgl-dev [!armhf !armel],
         libegl1-mesa-dev [armhf armel],
         libgles2-mesa-dev [armhf armel],
         libpng-dev,
         libxcomposite-dev (>= 1:0.3-2),
         libxfixes-dev (>=1:4.0.1),
         libxdamage-dev (>= 1:1.0.3),
         libxinerama-dev,
         libxrandr-dev (>=2:1.1.0.2),
         libxcursor-dev,
         libice-dev (>= 1:1.0.1),
         libsm-dev (>= 1:1.0.1),
         libstartup-notification0-dev (>= 0.7),
         libxslt1-dev,
         libxml2-dev,
         libx11-xcb-dev,
         libglib2.0-dev,
         libglibmm-2.4-dev,
         libgtk-3-dev,
Replaces: compiz-plugins-main-dev (<< 1:0.9.8),
          compiz-plugins-extra (<< 1:0.9.8),
          compiz-dev (<< 1:0.9.8),
Breaks: compiz-plugins-main-dev (<< 1:0.9.8),
        compiz-plugins-extra (<< 1:0.9.8),
Suggests: compiz-plugins
Description: OpenGL window and compositing manager - development files
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains the headers and libraries needed to compile compiz
 plugins.

Package: compiz-gnome
Architecture: any
Multi-Arch: no
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         compiz-plugins-default (= ${binary:Version}),
         gsettings-desktop-schemas,
         gnome-settings-daemon-common (>= 3.4.2-0ubuntu9),
         python3-gi
Recommends: gnome-system-monitor | mate-system-monitor,
Replaces: compiz-plugins-main (<= 1:0.9.8),
          compiz-plugins-main-default (<= 1:0.9.8),
          libcompizconfig0 (<= 1:0.9.8),
Breaks: compiz-plugins-main (<= 1:0.9.8),
        compiz-plugins-main-default (<= 1:0.9.8),
        unity (<< 7.5.0+19.04.20190208-0ubuntu1~),
Description: OpenGL window and compositing manager - GNOME window decorator
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains files needed to integrate compiz with the GNOME desktop
 environment.

Package: compiz-mate
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         compiz-gnome,
         mate-settings-daemon,
         python3
Recommends: ubuntu-mate-wallpapers-common,
Description: OpenGL window and compositing manager - MATE integration
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains files needed to integrate compiz with the MATE desktop
 environment.

Package: compiz-plugins-default
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: compiz-core (= ${binary:Version}),
         libdecoration0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
Replaces: compiz-plugins-main-default (<< 1:0.9.8),
          compiz-plugins (<< 1:0.9.12.1+15.10.20150724),
          compiz-core (<< 1:0.9.4+bzr20110606-0ubuntu3),
Breaks: compiz-plugins-main-default (<< 1:0.9.8),
        compiz-plugins (<< 1:0.9.12.1+15.10.20150724),
        compiz-core (<< 1:0.9.4+bzr20110606-0ubuntu3),
Description: OpenGL window and compositing manager - default plugins
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains the default set of core Compiz plugins.

Package: compiz-plugins
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: compiz-core (= ${binary:Version}),
         compiz-plugins-default (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
Replaces: compiz-plugins-main (<< 1:0.9.8),
          compiz-plugins-extra (<< 1:0.9.8),
          compiz-plugins-main-default (<< 1:0.9.8),
          compiz-core (<< 1:0.9.11+14.10.20140606),
Breaks: compiz-plugins-main (<< 1:0.9.8),
        compiz-plugins-extra (<< 1:0.9.8),
        compiz-core (<< 1:0.9.11+14.10.20140606),
Description: OpenGL window and compositing manager - plugins
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains the plugins that come with compiz but not officially
 supported.

Package: libdecoration0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: Compiz window decoration library
 The window decoration library is responsible for drawing the window borders
 and title bar of windows managed by Compiz. It is used by window decorators
 like gtk-window-decorator.

Package: libdecoration0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libdecoration0 (= ${binary:Version}),
         ${misc:Depends},
         libx11-dev,
         libxrender-dev (>= 1:0.9.1),
Description: Compiz window decoration library - development files
 The window decoration library is responsible for drawing the window borders
 and title bar of windows managed by Compiz. It is used by window decorators
 like gtk-window-decorator.
 .
 This package contains files required for developing window decorators
 compatible with Compiz.

Package: libcompizconfig0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         compiz-core (= ${binary:Version}),
Description: Settings library for plugins - OpenCompositing Project
 The OpenCompositing Project brings 3D desktop visual effects that improve
 usability of the X Window System and provide increased productivity
 through plugins and themes contributed by the community giving a
 rich desktop experience.
 .
 This package contains the library for plugins to configure settings.

Package: libcompizconfig0-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         libcompizconfig0 (= ${binary:Version}),
         compiz-dev,
Description: Development file for plugin settings - OpenCompositing Project
 The OpenCompositing Project brings 3D desktop visual effects that improve
 usability of the X Window System and provide increased productivity
 through plugins and themes contributed by the community giving a
 rich desktop experience.
 .
 This package contains the headers and development files needed to
 build plugins with settings support.

Package: python3-compizconfig
Architecture: any
Multi-Arch: same
Section: python
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Compizconfig bindings for Python
 Compiz Fusion is the result of the re-unification of the Beryl-project
 and the community around the Compiz Window Manager. It seeks to provide
 an easy and fun-to-use windowing environment, allowing use of the
 graphics hardware to provide impressive effects, amazing speed and
 unrivalled usefulness
 .
 This package provides Python bindings for the compizconfig system.

Package: compizconfig-settings-manager
Architecture: all
Multi-Arch: allowed
XB-Python3-Version: ${python3:Versions}
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},

## compiz 0.9.14.1+20.04.20220820-0ubuntu1

=== CMakeLists.txt ===
#
# Main CMakeLists.txt for compiz
#
project (compiz C CXX)

cmake_minimum_required (VERSION 3.10.0)

if (POLICY CMP0072)
    cmake_policy (SET CMP0072 OLD)
endif ()

if (POLICY CMP0077)
    cmake_policy (SET CMP0077 NEW)
endif ()

set (CMAKE_MODULE_PATH_ORIG ${CMAKE_MODULE_PATH})
set (COMPIZ_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${COMPIZ_CMAKE_MODULE_PATH})

include (CTest)
include (GNUInstallDirs)

set (MEMORYCHECK_COMMAND_OPTIONS --trace-children=yes)
set (MEMORYCHECK_SUPPRESSIONS_FILE ${CMAKE_SOURCE_DIR}/tests/experimental-memcheck/compiz.supp CACHE FILEPATH "" FORCE)

include (Dart)

# Common compiz CMake macros & functions.
include (CompizCommon)
# Packaging-specific CMake macros & functions.
include (CompizPackage)

# GSettings schema recompilation
include (CompizGSettings)

# Google Test and Xorg-GTest
include (XorgGTest)

include (cmake/base.cmake)
# Check if specific function is present in library.
include (CheckFunctionExists)

enable_testing()

# Import macro for doing coverage reporting
include(EnableCoverageReport)

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

#set (CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo;MinSizeRe" CACHE INTERNAL "" FORCE)
#if (NOT CMAKE_BUILD_TYPE)
#    set (CMAKE_BUILD_TYPE "Debug" CACHE STRING "Build type (Debug/Release/RelWithDebInfo/MinSizeRe)" FORCE)
#endif (NOT CMAKE_BUILD_TYPE)

file (READ ${CMAKE_SOURCE_DIR}/VERSION COMPIZ_RELEASE_VERSION LIMIT 12 OFFSET 0)
string (STRIP ${COMPIZ_RELEASE_VERSION} COMPIZ_RELEASE_VERSION)

set (VERSION ${COMPIZ_RELEASE_VERSION})

set (DECOR_INTERFACE_VERSION 20110504)

if (COMPIZ_PACKAGING_ENABLED)
    set (prefix ${CMAKE_INSTALL_PREFIX}                   CACHE PATH "prefix")
    set (exec_prefix ${CMAKE_INSTALL_PREFIX}/bin          CACHE PATH "bindir")
    set (libdir ${CMAKE_INSTALL_FULL_LIBDIR}              CACHE PATH "libdir")
    set (includedir ${CMAKE_INSTALL_FULL_INCLUDEDIR}      CACHE PATH "includedir")
    set (datadir ${CMAKE_INSTALL_FULL_DATAROOTDIR}        CACHE PATH "datadir")
else (COMPIZ_PACKAGING_ENABLED)
    set (prefix ${CMAKE_INSTALL_PREFIX}                 )
    set (exec_prefix ${CMAKE_INSTALL_PREFIX}/bin        )
    set (libdir ${CMAKE_INSTALL_FULL_LIBDIR}            )
    set (includedir ${CMAKE_INSTALL_FULL_INCLUDEDIR}    )
    set (datadir ${CMAKE_INSTALL_FULL_DATAROOTDIR}      )
endif (COMPIZ_PACKAGING_ENABLED)

set (compiz_plugindir ${libdir}/compiz)
set (compiz_sharedir ${datadir}/compiz/)
set (compiz_metadatadir ${datadir}/compiz)
set (COMPIZ_I18N_DIR ${CMAKE_SOURCE_DIR}/po)

# Force re-generation of uninstall script
compiz_set (_compiz_uninstall_rule_created FALSE)

# Don't allow subdirectories to add schema recompile rule
set_property (GLOBAL
	      PROPERTY GSETTINGS_LOCAL_COMPILE_INHIBIT_RULE
	      TRUE)
set_property (GLOBAL
	      PROPERTY COMPIZ_INHIBIT_ADD_INSTALL_RECOMPILE_RULE
	      TRUE)

# Translation
set (ALL_LINGUAS ace af am ar as ast az be bg bn_IN bn br bs ca ce cs cy da de el en_AU en_CA en_GB eo es et eu fa fil fi fr fy gl gu he hi hr hu id is it ja jv kab ka km kn ko ku ky lo lt lv mk ml mn mr ms my nb nds ne nl nn oc or pa pl pt_BR pt ro ru si sk sl sq sr sv ta te th tr ug uk vi xh zh_CN zh_HK zh_TW zu)
set (GETTEXT_PACKAGE compiz)

set (COMPIZ_REQUIRES
    x11
    xext
    xdamage
    xcomposite
    xcursor
    x11-xcb
    xrandr
    xinerama
    xi
    ice
    sm
    libxml-2.0
    libxslt
    glib-2.0
    gio-2.0
    glibmm-2.4
    "libstartup-notification-1.0 >= 0.7"
)

set (DECORATION_REQUIRES "xrender >= 0.9.3")

compiz_pkg_check_modules (COMPIZ REQUIRED ${COMPIZ_REQUIRES})
compiz_pkg_check_modules (LIBDECORATION REQUIRED ${DECORATION_REQUIRES})

include (CompizDefaults)

set (_compiz_package_string "Compiz ${VERSION}")
set (_compiz_package "Compiz")

compiz_configure_file (${compiz_SOURCE_DIR}/config.h.core.in ${compiz_BINARY_DIR}/generated/config.h)

compiz_configure_file (
    ${CMAKE_SOURCE_DIR}/compiz.pc.in
    ${CMAKE_BINARY_DIR}/compiz.pc
    COMPIZ_REQUIRES
    COMPIZ_CFLAGS
)

install (
    FILES ${CMAKE_BINARY_DIR}/compiz.pc
    DESTINATION ${libdir}/pkgconfig
)

set (COMPIZ_INTERNAL_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_SOURCE_DIR}/src/timer/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/string/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/pluginclasshandler/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/point/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/rect/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/servergrab/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/region/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/window/geometry/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/window/geometry-saver/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/window/extents/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/window/constrainment/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src/logmessage/include)

if (COMPIZ_BUILD_TESTING)

    include (GoogleTest)

    if (GOOGLE_TEST_AND_MOCK_FOUND)

	if (BUILD_XORG_GTEST)

	    find_package (XorgGTest)

	    set (COMPIZ_XORG_GTEST_DIR ${CMAKE_BINARY_DIR}/__xorg_gtest CACHE PATH "Path to Xorg GTest build dir" FORCE)
	    set (COMPIZ_XORG_GTEST_WRAPPER ${COMPIZ_XORG_GTEST_DIR}/xorg_gtest_wrapper CACHE PATH "Path to Xorg GTest wrapper" FORCE)

	    if (XORG_GTEST_FOUND)

		build_xorg_gtest_locally (${CMAKE_BINARY_DIR}/__xorg_gtest)

	    else (XORG_GTEST_FOUND)

		set (BUILD_XORG_GTEST FALSE)

	    endif (XORG_GTEST_FOUND)

	endif (BUILD_XORG_GTEST)

    else (GOOGLE_TEST_AND_MOCK_FOUND)

	set (COMPIZ_BUILD_TESTING OFF CACHE BOOL "" FORCE)
	set (BUILD_XORG_GTEST OFF CACHE BOOL "" FORCE)

    endif (GOOGLE_TEST_AND_MOCK_FOUND)

else (COMPIZ_BUILD_TESTING)

    set (BUILD_XORG_GTEST OFF CACHE BOOL "" FORCE)

endif (COMPIZ_BUILD_TESTING)

# Add the rest of compiz
add_subdirectory (cmake)
add_subdirectory (include)
add_subdirectory (images)
add_subdirectory (libdecoration)
add_subdirectory (gtk)
add_subdirectory (po)
add_subdirectory (metadata)
add_subdirectory (src)
add_subdirectory (compizconfig)
add_subdirectory (xslt)
add_subdirectory (plugins)
add_subdirectory (tests)

# Leave last - the cmake_install.cmake script is guaranteed
# to run in a single job, and we need to force GSettings
# schema recompilation to happen after all other install
# targets (there is no way to set install target dependencies)
# in CMake
add_subdirectory (postinst)

compiz_ensure_linkage ()
compiz_package_generation ("Compiz")
compiz_add_uninstall ()
compiz_add_git_dist ()
compiz_add_distcheck ()
compiz_add_release ()
compiz_add_release_signoff ()

if (COMPIZ_BUILD_TESTING)
    compiz_generate_testfile_target ()
endif (COMPIZ_BUILD_TESTING)

_print_configure_results ()

_check_compiz_cmake_macro (${CMAKE_MODULE_PATH_ORIG})

# Enable coverage reporting for compiz
compiz_generate_coverage_report()

=== gtk/CMakeLists.txt ===
option (BUILD_GTK "Build gtk-window-decorator and Gnome related toold" 1)
option (BUILD_METACITY "Gtk-window-decorator metacity theme support" 1)
option (BUILD_GNOME "GNOME integration" 1)

compiz_set (USE_GTK ${BUILD_GTK})
compiz_set (USE_METACITY ${BUILD_METACITY})
compiz_set (USE_GNOME ${BUILD_GNOME})

if (USE_GTK)
    pkg_check_modules (GTK_WINDOW_DECORATOR
	xrender>=0.8.4
	gtk+-3.0
	libwnck-3.0
	pangocairo
    )
    if (GTK_WINDOW_DECORATOR_FOUND)
        set (CMAKE_REQUIRED_FLAGS ${GTK_WINDOW_DECORATOR_CFLAGS})
        set (CMAKE_REQUIRED_LIBRARIES ${GTK_WINDOW_DECORATOR_LIBRARIES})
        list (FIND CMAKE_REQUIRED_FLAGS "-D_REENTRANT" REENTRANT_INDEX)
        if (REENTRANT_INDEX)
          list (REMOVE_AT CMAKE_REQUIRED_FLAGS REENTRANT_INDEX)
          list (APPEND CMAKE_REQUIRED_FLAGS "-D_REENTRANT=1")
        endif (REENTRANT_INDEX)
        set (CMAKE_REQUIRED_FLAGS "")
        set (CMAKE_REQUIRED_LIBRARIES "")

        if (USE_METACITY)
            pkg_check_modules (LIBMETACITY libmetacity>=3.22.0)

            if (LIBMETACITY_FOUND)
                compiz_pkg_check_modules (HAVE_METACITY_3_26_0 libmetacity>=3.25.1)

                set (METACITY_INCLUDE_DIRS ${LIBMETACITY_INCLUDE_DIRS})
                set (METACITY_LIBRARIES ${LIBMETACITY_LIBRARIES})
            else (LIBMETACITY_FOUND)
                compiz_set (USE_METACITY 0)
            endif (LIBMETACITY_FOUND)
        endif (USE_METACITY)

    else (GTK_WINDOW_DECORATOR_FOUND)
	compiz_set (USE_GTK 0)
    endif (GTK_WINDOW_DECORATOR_FOUND)
endif (USE_GTK)

if (NOT USE_GTK)
    compiz_set (USE_METACITY 0)
endif (NOT USE_GTK)

configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h.gtk.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
)

add_subdirectory (window-decorator)
add_subdirectory (gnome)

=== src/CMakeLists.txt ===
set (COMPIZ_MAIN_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set (COMPIZ_MAIN_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

include (CompizBcop)

add_subdirectory( string )
add_subdirectory( logmessage )
add_subdirectory( timer )
add_subdirectory( pluginclasshandler )
add_subdirectory( point )
add_subdirectory( rect )
add_subdirectory( region )
add_subdirectory( window )
add_subdirectory( servergrab )

IF (COMPIZ_BUILD_TESTING)
add_subdirectory( privatescreen/tests )
add_subdirectory( wrapsystem/tests )
add_subdirectory( plugin )
add_subdirectory( option/tests )
add_subdirectory( tests )
ENDIF (COMPIZ_BUILD_TESTING)

compiz_add_bcop_targets (
    core
    ${compiz_BINARY_DIR}/generated/core.xml.in
    _bcop_sources
)

get_property (CORE_MOD_INCLUDE_DIRS
	      GLOBAL
	      PROPERTY CORE_MOD_INCLUDE_DIRS)

include_directories (
    ${compiz_SOURCE_DIR}/include
    ${compiz_BINARY_DIR}
    ${compiz_BINARY_DIR}/generated
    ${COMPIZ_INCLUDE_DIRS}
    ${CMAKE_PREFIX_PATH}/include
    ${CMAKE_INCLUDE_PATH}
    ${CORE_MOD_INCLUDE_DIRS}
    
    ${CMAKE_CURRENT_SOURCE_DIR}
    
    # Module specific include dirs
    ${CMAKE_CURRENT_SOURCE_DIR}/string/include
    ${CMAKE_CURRENT_SOURCE_DIR}/string/src
    
    ${CMAKE_CURRENT_SOURCE_DIR}/logmessage/include
    ${CMAKE_CURRENT_SOURCE_DIR}/logmessage/src
    
    ${CMAKE_CURRENT_SOURCE_DIR}/timer/include
    ${CMAKE_CURRENT_SOURCE_DIR}/timer/src
    
    ${CMAKE_CURRENT_SOURCE_DIR}/pluginclasshandler/include
    ${CMAKE_CURRENT_SOURCE_DIR}/pluginclasshandler/src

    ${CMAKE_CURRENT_SOURCE_DIR}/point/include
    ${CMAKE_CURRENT_SOURCE_DIR}/point/src

    ${CMAKE_CURRENT_SOURCE_DIR}/rect/include
    ${CMAKE_CURRENT_SOURCE_DIR}/rect/src

    ${CMAKE_CURRENT_SOURCE_DIR}/servergrab/include
    ${CMAKE_CURRENT_SOURCE_DIR}/servergrab/src

    ${CMAKE_CURRENT_SOURCE_DIR}/region/include
    ${CMAKE_CURRENT_SOURCE_DIR}/region/src

    ${CMAKE_CURRENT_SOURCE_DIR}/window/geometry/include
    ${CMAKE_CURRENT_SOURCE_DIR}/window/geometry/src

    ${CMAKE_CURRENT_SOURCE_DIR}/window/geometry-saver/include
    ${CMAKE_CURRENT_SOURCE_DIR}/window/geometry-saver/src

    ${CMAKE_CURRENT_SOURCE_DIR}/window/extents/include
    ${CMAKE_CURRENT_SOURCE_DIR}/window/extents/src

    ${CMAKE_CURRENT_SOURCE_DIR}/window/constrainment/include
    ${CMAKE_CURRENT_SOURCE_DIR}/window/constrainment/src
)

add_definitions (
    -DHAVE_CONFIG_H
    -DPLUGINDIR="${compiz_plugindir}"
    -DSHAREDIR="${compiz_sharedir}"
    -DMETADATADIR="${compiz_metadatadir}"
)

get_property (CORE_MOD_LIBRARY_DIRS
	      GLOBAL
	      PROPERTY CORE_MOD_LIBRARY_DIRS)

link_directories (
    ${COMPIZ_LINK_DIRS}
    ${CORE_MOD_LIBRARY_DIRS}
    ${libdir}
)

add_library (compiz_core SHARED
    ${CMAKE_CURRENT_SOURCE_DIR}/global.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/atoms.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/actions.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/screen.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/window.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/action.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/option.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/match.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/event.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/session.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/windowgeometry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/icon.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/modifierhandler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/propertywriter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/eventsource.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/signalsource.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackdebugger.cpp

    ${_bcop_sources}
)

add_dependencies (core-options core-xml-file)
add_dependencies (compiz_core core-options)

#
# Normal libraries use the major version number of the library as their
# ABI version. But compiz uses funky date numbers for ABI revisions instead.
#
set (abiversion_h "${compiz_SOURCE_DIR}/include/core/abiversion.h")
file (STRINGS ${abiversion_h} abiline REGEX "^#define +CORE_ABIVERSION .+$")
string (REGEX REPLACE "#define +CORE_ABIVERSION +" "" abiversion "${abiline}")
set_target_properties (compiz_core PROPERTIES
    VERSION ${VERSION}
    SOVERSION "ABI-${abiversion}"
)

add_executable (compiz
    ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
)

add_library (compiz_size STATIC
    size.cpp
)
add_library (compiz_output STATIC
    output.cpp
)

add_library (compiz_outputdevices STATIC
    outputdevices.cpp
    outputdevices_x11.cpp
)

add_dependencies (compiz_outputdevices
    core-options
    compiz_size
    compiz_output
    compiz_rect
    compiz_region
    compiz_window_geometry
)

add_library (compiz_configurerequestbuffer STATIC
             configurerequestbuffer.cpp)

target_link_libraries (compiz_configurerequestbuffer
                       compiz_window_geometry)

# workaround for build race
add_dependencies (compiz core-xml-file)

get_property (CORE_MOD_LIBRARIES
	      GLOBAL
	      PROPERTY CORE_MOD_LIBRARIES)

target_link_libraries (
    compiz_core
    
    ${COMPIZ_LIBRARIES} 
    
    m 
    pthread 
    dl
    
    -Wl,-whole-archive
    compiz_size
    compiz_string
    compiz_timer
    compiz_logmessage
    compiz_pluginclasshandler
    compiz_point
    compiz_rect
    compiz_region
    compiz_window_geometry
    compiz_window_geometry_saver
    compiz_window_extents
    compiz_window_constrainment
    compiz_servergrab
    compiz_output
    compiz_outputdevices
    compiz_configurerequestbuffer
    -Wl,-no-whole-archive
#    ${CORE_MOD_LIBRARIES}
)

#
# Tell CMake that targets using compiz_core should NOT re-import the
# libraries that compiz_core depends on (contains).
#
set_target_properties (compiz_core PROPERTIES
    INTERFACE_LINK_LIBRARIES ""
)

target_link_libraries (
    compiz
    compiz_core
)

install (
    TARGETS compiz_core
  	LIBRARY DESTINATION ${libdir}
)

install (
    TARGETS compiz
    RUNTIME DESTINATION ${exec_prefix}
)

enable_coverage_report( TARGETS compiz )

=== compizconfig/compizconfig-python/CMakeLists.txt ===
# Hack
set (CMAKE_PROJECT_NAME compizconfig-python)

# Get arch
execute_process (COMMAND uname -p OUTPUT_VARIABLE PROC_ARCH)
string (REPLACE "\n" "" PROC_ARCH ${PROC_ARCH})

find_package (PythonInterp 3.0 REQUIRED)
find_package (PythonLibs 3.0 REQUIRED)

set (COMPIZCONFIG_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/compizconfig/libcompizconfig/include)

set (PY_VERSION "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
set (PY_BUILD_DIR lib.linux-${PROC_ARCH}-${PY_VERSION})
set (PY_SCRIPTS_DIR scripts-${PY_VERSION})
set (PY_COMPIZCONFIG_SRC ${CMAKE_CURRENT_BINARY_DIR}/compizconfig.c)
set (PY_COMPIZCONFIG_CYTHON ${CMAKE_CURRENT_SOURCE_DIR}/src/compizconfig.pyx)

find_program(CYTHON_BIN cython3)
if(NOT CYTHON_BIN)
  message(FATAL_ERROR "Can not build because cython binary not found.")
endif()

add_custom_command (OUTPUT ${PY_COMPIZCONFIG_SRC}
		    COMMAND ${CYTHON_BIN} -o ${PY_COMPIZCONFIG_SRC} ${PY_COMPIZCONFIG_CYTHON}
		    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		    DEPENDS ${PY_COMPIZCONFIG_CYTHON})

file (READ ${CMAKE_SOURCE_DIR}/VERSION COMPIZ_RELEASE_VERSION LIMIT 12 OFFSET 0)
string (STRIP ${COMPIZ_RELEASE_VERSION} COMPIZ_RELEASE_VERSION)
set (VERSION ${COMPIZ_RELEASE_VERSION})

include_directories (${PYTHON_INCLUDE_DIRS}
		     ${COMPIZCONFIG_INCLUDE_DIRS})

# cython generates code that does type-punning, this trips
# up -Werror
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-strict-aliasing")

# We need to remove the "lib"
set (CMAKE_SHARED_LIBRARY_PREFIX "")

# We must build the python module using CMake instead of distutils.
#
# The only way in which the python module can be built using distutils
# is by using add_custom_command to "generate" it into existence.
# Unfortunately this has drawbacks. Namely, it is not possible for
# add_custom_command to depend on library targets. Because of that, there's
# no way that we can guarantee that libcompizconfig.so will be linked
# before compizconfig.so (which is required). The best that we can do
# there is to use add_custom_target, and make that target depend on the
# file, 
add_library (compizconfig_python_module SHARED
	     ${PY_COMPIZCONFIG_SRC})

set_target_properties (compizconfig_python_module
		       PROPERTIES
		       OUTPUT_NAME
		       compizconfig)

target_link_libraries (compizconfig_python_module
		       ${PYTHON_LIBRARIES}
		       compizconfig)

set (UNINSTALL_COMMAND "${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/setup.py uninstall --prefix=${CMAKE_INSTALL_PREFIX} --version=${VERSION}")

compiz_add_code_to_uninstall_target (${UNINSTALL_COMMAND} ${CMAKE_CURRENT_BINARY_DIR})

# This is probably not very portable, but we can't install using distutils
# as we cannot build with it safely

if ($ENV{COMPIZ_DEB_BUILD})
    set (INSTALL_LAYOUT_DIR dist-packages)
else ($ENV{COMPIZ_DEB_BUILD})
    set (INSTALL_LAYOUT_DIR site-packages)
endif ($ENV{COMPIZ_DEB_BUILD})

set (PYTHON_MODULE_DIR ${CMAKE_INSTALL_PREFIX}/lib/python${PY_VERSION}/${INSTALL_LAYOUT_DIR})

install (TARGETS compizconfig_python_module
	 DESTINATION ${PYTHON_MODULE_DIR})

install (CODE
	 "message (\"Installing python files\")
	  execute_process (COMMAND cmake -DPY_EXECUTABLE=${PYTHON_EXECUTABLE} -DSETUP=${CMAKE_CURRENT_SOURCE_DIR}/setup.py -DPREFIX=${CMAKE_INSTALL_PREFIX} -DWDIR=${CMAKE_CURRENT_BINARY_DIR} -DVERSION=${VERSION} -P ${compiz_SOURCE_DIR}/compizconfig/cmake/exec_setup_py_with_destdir.cmake)")

if (COMPIZ_BUILD_TESTING)

        find_program (BASH_EXECUTABLE bash)
	mark_as_advanced (FORCE PYTHON_EXECUTABLE)

	file (GLOB PYTHON_TESTS "tests/test_*.py")

        if (PYTHON_EXECUTABLE AND
            BASH_EXECUTABLE)
		set (MOCK_XML_SRC ${CMAKE_CURRENT_SOURCE_DIR}/tests/mock.xml)
		set (MOCK_XML_FILE ${CMAKE_CURRENT_BINARY_DIR}/mock.xml)

		add_custom_command (OUTPUT ${MOCK_XML_FILE}
				    COMMAND cp ${MOCK_XML_SRC}
					    ${MOCK_XML_FILE}
				    COMMENT "Copying mock.xml file into testing directory"
				    DEPENDS ${MOCK_XML_SRC})

		add_custom_target (compizconfig_python_test_mock_xml_file ALL DEPENDS
				   ${MOCK_XML_FILE})

		# For testing purposes we need the ini backend
		add_dependencies (compizconfig_python_module ini compizconfig_python_test_mock_xml_file)

		foreach (PYTHON_TEST_FILE ${PYTHON_TESTS})
			get_filename_component (PYTHON_TEST ${PYTHON_TEST_FILE} NAME_WE)
			message (STATUS "Adding test " ${PYTHON_TEST})
                        add_test (NAME CompizConfigPython.${PYTHON_TEST}
                                  WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
                                  COMMAND ${BASH_EXECUTABLE}
                                  ${CMAKE_SOURCE_DIR}/tests/util/run_with_ld_library_path.sh
                                  ${CMAKE_BINARY_DIR}/compizconfig/libcompizconfig/src
                                  ${PYTHON_EXECUTABLE} ${PYTHON_TEST_FILE})
		endforeach (PYTHON_TEST_FILE)
        endif (PYTHON_EXECUTABLE AND
               BASH_EXECUTABLE)

endif (COMPIZ_BUILD_TESTING)

=== plugins/crashhandler/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

compiz_plugin (crashhandler)

=== plugins/decor/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)
include (CompizCommon)

include_directories (${CMAKE_CURRENT_SOURCE_DIR}/src/clip-groups/include/)
include_directories (${CMAKE_CURRENT_SOURCE_DIR}/src/pixmap-requests/include/)

compiz_plugin(decor PLUGINDEPS composite opengl LIBRARIES decoration compiz_decor_clip_groups compiz_decor_pixmap_requests)

add_subdirectory (src/clip-groups)
add_subdirectory (src/pixmap-requests)

if (COMPIZ_BUILD_WITH_RPATH AND NOT COMPIZ_DISABLE_PLUGIN_DECOR)

    set_target_properties (
	decor PROPERTIES
	INSTALL_RPATH "${COMPIZ_LIBDIR}"
    )
endif (COMPIZ_BUILD_WITH_RPATH AND NOT COMPIZ_DISABLE_PLUGIN_DECOR)

install (PROGRAMS "src/compiz-decorator" DESTINATION ${exec_prefix})

add_subdirectory (tests)

=== plugins/resize/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

add_subdirectory (src/logic)
include_directories (src/logic/include)

compiz_plugin(resize PLUGINDEPS composite opengl LIBRARIES resize_logic)

=== plugins/session/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

compiz_plugin (session PKGDEPS libxml-2.0)

=== compizconfig/gsettings/mocks/CMakeLists.txt ===
pkg_check_modules (GLIB glib-2.0)

if (GLIB_FOUND)

    include_directories (${CMAKE_CURRENT_SOURCE_DIR}
			 ${CMAKE_CURRENT_BINARY_DIR}
			 ${CMAKE_CURRENT_SOURCE_DIR}/../../libcompizconfig/include
			 ${CMAKE_CURRENT_SOURCE_DIR}/../gsettings_backend_shared
			 ${GLIB_INCLUDE_DIRS})

    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

    add_library (compizconfig_ccs_gsettings_wrapper_mock STATIC
	         ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_wrapper_mock.cpp
	         ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_wrapper_mock.h)

    add_library (compizconfig_ccs_gsettings_wrapper_factory_mock STATIC
	         ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_wrapper_factory_mock.cpp
	         ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_wrapper_factory_mock.h)

    add_library (compizconfig_ccs_gsettings_backend_mock STATIC
	         ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_backend_mock.cpp
	         ${CMAKE_CURRENT_SOURCE_DIR}/ccs_gsettings_backend_mock.h)

endif (GLIB_FOUND)

=== compizconfig/libcompizconfig/backend/CMakeLists.txt ===
set (CMAKE_MODULE_PATH_ORIG ${CMAKE_MODULE_PATH})
set (LIBCOMPIZCONFIG_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../cmake)
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${LIBCOMPIZCONFIGZ_CMAKE_MODULE_PATH})

# Sorry for the kittens
include (${CMAKE_CURRENT_SOURCE_DIR}/../cmake/LibCompizConfigCommon.cmake)

compizconfig_backend (ini)

=== src/region/tests/CMakeLists.txt ===
include_directories( 
  ${CMAKE_CURRENT_SOURCE_DIR} 

  ${compiz_SOURCE_DIR}/src/rect/include
  ${compiz_SOURCE_DIR}/src/region/include
  ${compiz_SOURCE_DIR}/include
  ${compiz_SOURCE_DIR}/src
)

add_definitions (
    -DHAVE_CONFIG_H
    -DPLUGINDIR="${compiz_plugindir}"
    -DSHAREDIR="${compiz_sharedir}"
    -DMETADATADIR="${compiz_metadatadir}"
)

add_executable( 
  compiz_region_test
  
  ${CMAKE_CURRENT_SOURCE_DIR}/test-region.cpp
)

target_link_libraries( 
  compiz_region_test 
  
  compiz_region
  compiz_rect
  compiz_point
  
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARY}
)

compiz_discover_tests (compiz_region_test COVERAGE compiz_region)

=== src/wrapsystem/tests/CMakeLists.txt ===
include_directories( 
  ${CMAKE_CURRENT_SOURCE_DIR}/../../../include
)

add_executable( 
  compiz_wrapsystem_test
  
  ${CMAKE_CURRENT_SOURCE_DIR}/test-wrapsystem.cpp
)

target_link_libraries( 
  compiz_wrapsystem_test
  
  ${GTEST_BOTH_LIBRARIES}
)

compiz_discover_tests (compiz_wrapsystem_test COVERAGE compiz_core)

## compiz 0.9.14.1+20.10.20200427-0ubuntu2

=== plugins/place/src/constrain-to-workarea/CMakeLists.txt ===
pkg_check_modules (
  GLIBMM
  REQUIRED
  glibmm-2.4 glib-2.0
)

INCLUDE_DIRECTORIES (  
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/src

  ${compiz_SOURCE_DIR}/src/point/include
  ${compiz_SOURCE_DIR}/src/rect/include
  ${compiz_SOURCE_DIR}/src/window/geometry/include
  ${compiz_SOURCE_DIR}/src/window/geometry-saver/include
  ${compiz_SOURCE_DIR}/src/window/extents/include
  ${compiz_SOURCE_DIR}/include
    
  ${Boost_INCLUDE_DIRS}
  
  ${GLIBMM_INCLUDE_DIRS}
)

LINK_DIRECTORIES (${GLIBMM_LIBRARY_DIRS}) 

SET ( 
  PUBLIC_HEADERS 
)

SET ( 
  PRIVATE_HEADERS
  ${CMAKE_CURRENT_SOURCE_DIR}/include/constrain-to-workarea.h
)

SET( 
  SRCS 
  ${CMAKE_CURRENT_SOURCE_DIR}/src/constrain-to-workarea.cpp
  ${compiz_SOURCE_DIR}/src/size.cpp
)

ADD_LIBRARY( 
  compiz_place_constrain_to_workarea STATIC
  
  ${SRCS}
  
  ${PUBLIC_HEADERS}
  ${PRIVATE_HEADERS}
)

if (COMPIZ_BUILD_TESTING)
ADD_SUBDIRECTORY( ${CMAKE_CURRENT_SOURCE_DIR}/tests )
endif (COMPIZ_BUILD_TESTING)

SET_TARGET_PROPERTIES(
  compiz_place_constrain_to_workarea PROPERTIES
  PUBLIC_HEADER "${PUBLIC_HEADERS}"
)

TARGET_LINK_LIBRARIES(
  compiz_place_constrain_to_workarea

  compiz_core
  ${GLIBMM_LIBRARIES}
)

=== debian/changelog ===
compiz (1:0.9.14.1+20.10.20200427-0ubuntu2) groovy; urgency=medium

  * No-change rebuild against libprotobuf22

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 May 2020 21:27:25 +0000
